package md

type AppletApplicationAdSpaceListReq struct {
	Limit          string `json:"limit"`
	Page           string `json:"page" `
	Name           string `json:"name"`
	CooperateState string `json:"cooperate_state" example:"合作状态"`
	AdType         string `json:"ad_type" example:"广告位类型"`
	Platform       string `json:"platform"`
}
type AppletApplicationAdSpaceListRes struct {
	List           []AppletApplicationAdSpaceListData `json:"list"`
	Total          int64                              `json:"total"`
	State          []SelectData                       `json:"state"`
	CooperateState []SelectData                       `json:"cooperate_state"`
	Platform       []SelectData                       `json:"platform"`
	AdType         []SelectData                       `json:"ad_type"`
	Application    []map[string]string                `json:"application"`
}
type AppletApplicationAdSpaceListData struct {
	Id             string `json:"id" example:"id"`
	Name           string `json:"name" example:"应用名称"`
	Platform       string `json:"platform" example:"平台"`
	Kind           string `json:"kind" example:"广告位类型"`
	Memo           string `json:"memo" example:"备注"`
	Logo           string `json:"logo" example:"logo"`
	AppId          string `json:"app_id" example:"小程序appid"`
	AdId           string `json:"ad_id" example:"广告位id"`
	State          string `json:"state" example:"应用状态 state=2 才能再次编辑"`
	CooperateState string `json:"cooperate_state" example:"合作状态"`
	AppName        string `json:"app_name"`
}
type AppletApplicationAdSpaceSaveReq struct {
	Name  string `json:"name" example:"应用名称"`
	AppId string `json:"app_id" example:"小程序appid"`
	Kind  string `json:"kind" example:"广告类型"`
}
